/*
 * Copyright 2016 - 2024 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include <keel/module.hpp>

namespace keel {

static ox::Vector<Module const*> mods;

void registerModule(Module const*mod) noexcept {
	mods.emplace_back(mod);
}

[[nodiscard]]
ox::Vector<Module const*> const&modules() noexcept {
	return mods;
}


ox::Vector<TypeDescGenerator> Module::types() const noexcept {
	return {};
}

ox::Vector<keel::BaseConverter const*> Module::converters() const noexcept {
	return {};
}

ox::Vector<PackTransform> Module::packTransforms() const noexcept {
	return {};
}

}
