/*
 * Copyright 2016 - 2024 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <ox/event/signal.hpp>

#include <turbine/context.hpp>

#include "project.hpp"

namespace studio {

struct StudioContext {
	class StudioUI *ui = nullptr;
	Project *project = nullptr;
	turbine::Context &tctx;
	inline explicit StudioContext(turbine::Context &pTctx) noexcept: tctx(pTctx) {}
};

}
